#include "global.h"

static Token longjmp_stack_t, unwind_t, longjmp_base;
static Token longjmp_ctx_top;
static Token longjmp_ctx;

void init_except ()
{
	longjmp_stack_t = new_symbol ("longjmp_StaCk");
	unwind_t = new_symbol ("AuToDt_t");
	longjmp_ctx_top = new_symbol ("longjmp_StaCkTop");
	longjmp_ctx = new_symbol ("longjmp_CoNtExT");
	longjmp_base = new_symbol ("longjmp_iNiTObjFaKe");
}

static char _Unwind_gcc [] =
" /*"COLS"*** gcc unwind internals ***"COLE"*/\n"
" /* according to the manual, this is not the right way to catch\n"
"    exceptions. ``It is undefined what happens if the cleanup function\n"
"    does not return''.  Our cleanup function is __lwc_landingpad and it's\n"
"    the one that longjmps to the catch point. The ''right'' way, according\n"
"    to what's happening in glibc 2.3.3 (not available to the public. \n"
"                                  ), is to place the longjmp in the ThRoW_sToP\n"
"    function. But we have to implement our own accounting, check things like\n"
"    STACK_GROWS_UP, dive into hairy arch/bits/files and use even more gcc\n"
"    internals. For the moment this works, is simpler and we can't do the other\n"
"    thing unless some guru helps us out. Let us all pray it will always work.  */\n"
" /* **may not work with NPTL** don't mix pthread cancellations and lwc exceptions! */\n"
" static _Unwind_Reason_Code"
" ThRoW_sToP ( )"
" {"
"  return _URC_NO_REASON ;"
" }"
""
" void __lwc_unwind ( int i )"
" {"
"  struct _Unwind_Exception * exc = malloc ( sizeof * exc ) ;"
"  exc -> exception_class = 0 ;"
"  exc -> exception_cleanup = 0 ;"
"  longjmp_StaCkTop -> X = i ;"
"  longjmp_StaCkTop -> i = exc ;"
#ifndef __USING_SJLJ_EXCEPTIONS__
"  _Unwind_ForcedUnwind ( exc , ThRoW_sToP,  0 ) ;"
#else
"  _Unwind_SjLj_ForcedUnwind ( exc , ThRoW_sToP , 0 ) ;"
#endif
" \n/* did you forget -fexceptions ? */ * ( int * ) 0 = 0 ;"
"}"
" void __lwc_landingpad ( int * i ) "
" {"
"  if ( ! * i ) "
"   longjmp ( * longjmp_StaCkTop -> x , longjmp_StaCkTop -> X ) ;"
" }";

#define IFEH if (EHUnwind) {
#define IFNEH if (!EHUnwind) {
#define ELSE } else {
#define ENDIF }

void decl_except_data ()
{
	outprintf (INCLUDE, include_sys_header_s ("setjmp.h"), -1);
IFEH	// include <unwind.h>
	outprintf (INCLUDE, include_sys_header_s ("unwind.h"), -1);
ENDIF

IFNEH	// declare manual unwind accounting
	outprintf (STRUCTS,
		RESERVED_struct, unwind_t, '{',
		RESERVED_struct, unwind_t, '*', RESERVED_X, ';',
		RESERVED_void, '*', RESERVED_x, ';',
		RESERVED_void, '*', '(', '*' , RESERVED_y, ')', '(', RESERVED_void, '*', ')', ';',
		'}', ';', -1);
ENDIF

	outprintf (STRUCTS,
		RESERVED_struct, longjmp_stack_t, '{',
		RESERVED_jmp_buf, '*', RESERVED_x, ';',
		RESERVED_struct, longjmp_stack_t, '*', RESERVED_y, ';',
		RESERVED_int, RESERVED_X, ';', -1);
IFEH	// cleanup eh mess
	outprintf (STRUCTS, RESERVED_void, '*', RESERVED_i, ';', -1);
ELSE	// accounting member
	outprintf (STRUCTS, RESERVED_struct, unwind_t, '*', RESERVED_i, ';', -1);
ENDIF
	outprintf (STRUCTS, '}', ';', -1);

	if (MainModule)
		outprintf (GVARS, Reentrant ? RESERVED___thread : BLANKT,
			   RESERVED_struct, longjmp_stack_t, longjmp_base, ',', '*',
			   longjmp_ctx_top, '=', '&', longjmp_base, ';', -1);
	else
		outprintf (GVARS, RESERVED_extern,
			   Reentrant ? RESERVED___thread : BLANKT,
			   RESERVED_struct, longjmp_stack_t, '*', longjmp_ctx_top, ';', -1);

#define EHTOP longjmp_ctx_top, POINTSAT
#define ADTOP EHTOP, RESERVED_i
	if (!MainModule) {
		outprintf (GVARS, RESERVED_extern, RESERVED_void, RESERVED___lwc_unwind,
			   '(', RESERVED_int, ')', -1);
#ifdef	HAVE_GNUC_ATTR_NORETURN
		outprintf (GVARS, RESERVED___attribute__, '(', '(',RESERVED_noreturn,')', ')', -1);
#endif
		output_itoken (GVARS, ';');
IFEH		// landing pad prototype
		outprintf (GVARS, RESERVED_extern, RESERVED_void, RESERVED___lwc_landingpad,
			   '(', RESERVED_int, '*', ')', ';', -1);
ENDIF
	} else
		if (!EHUnwind)
		outprintf (GVARS, RESERVED_void, RESERVED___lwc_unwind, '(', RESERVED_int,
			   RESERVED_X, ')', '{',
			   EHTOP, RESERVED_X, '=', RESERVED_X, ';',
			   RESERVED_while, '(', ADTOP, ')', '{',
			   ADTOP, POINTSAT, RESERVED_y, '(', ADTOP, POINTSAT, RESERVED_x, ')', ';',
			   ADTOP, '=', ADTOP, POINTSAT, RESERVED_X, ';', '}',
			   RESERVED_longjmp, '(', '*',
			   EHTOP, RESERVED_x, ',', RESERVED_X, ')', ';', '}', -1);
		else output_itoken (GVARS, new_symbol (_Unwind_gcc));
}


void push_unwind (OUTSTREAM o, recID r, Token arg)
{
	if (EHUnwind) return;
#define NOWARNONTYPE '(', RESERVED___typeof__, '(', u, '.', RESERVED_y, ')', ')'
	Token u = internal_identifier1 ();
	outprintf (o, RESERVED_struct, unwind_t, u, '=', '{',
		   '.', RESERVED_X, '=', ADTOP, ',',
		   '.', RESERVED_x, '=', '&', arg, ',',
		   '.', RESERVED_y, '=', NOWARNONTYPE, dtor_name (r), ',',
		   '}', ';', ADTOP, '=', '&', u, ';', -1);
}

void pop_unwind (OUTSTREAM o)
{
	if (EHUnwind) return;
	outprintf (o, ADTOP, '=', ADTOP, POINTSAT, RESERVED_X, ';', -1);
}

NormPtr throw_statement (OUTSTREAM o, NormPtr p)
{
	outprintf (o, RESERVED___lwc_unwind, '(', -1);

	if (CODE [p] == ';')
		output_itoken (o, RESERVED_1);
	else { 
		exprret E;
		p = parse_expression_retconv (p, &E, typeID_int, NORMAL_EXPR);
		if (!E.ok) return p + 1;
		outprintf (o, ISTR (E.newExpr), -1);

		free (E.newExpr);
		if (CODE [p] != ';')
			parse_error (p, "excepted ';' after throw expression");
	}

	outprintf (o, ')', ';', -1);

	return p + 1;
}

NormPtr try_statement (OUTSTREAM o, NormPtr p)
{
	Token x = RESERVED_x;
	Token y = RESERVED_y;
	Token X = RESERVED_X;
	Token i = RESERVED_i;
	Token ii = internal_identifier2 ();
	Token i3 = internal_identifier3 ();
	Token retcode;
	bool have_retcode;

	if (have_retcode = CODE [p] == '(') {
		open_local_scope ();
		if (!issymbol (retcode = CODE [++p]))
			parse_error (p, "try ( 'identifier' )");
		if (CODE [++p] != ')')
			parse_error (p, "try (identifier ')'");
		++p;
		enter_local_obj (retcode, typeID_int);
	} else retcode = internal_identifier1 ();

	outprintf (o, '{', RESERVED_struct, longjmp_stack_t, longjmp_ctx, ';',
		   RESERVED_int, retcode, ';',
		   RESERVED_jmp_buf, ii, ';', longjmp_ctx, '.', x, '=', '&', ii, ';',
		   longjmp_ctx, '.', y, '=', longjmp_ctx_top, ';', longjmp_ctx_top,
		   '=', '&', longjmp_ctx, ';', longjmp_ctx, '.', X, '=', RESERVED_0, ';', -1);
IFNEH	// init manual accounting
	outprintf (o, longjmp_ctx, '.', RESERVED_i, '=', RESERVED_0, ';', -1);
ENDIF
	outprintf (o,
		   RESERVED_if, '(', '!', '(', retcode, '=', RESERVED_setjmp, '(', ii, ')', ')',
		   ')', '{', -1);

IFEH	// cleanup with landing pad
	outprintf (o, RESERVED_int, i3, cleanup_func (RESERVED___lwc_landingpad),
				 '=', RESERVED_0, ';', -1);
ENDIF

	p = statement (o, p);

IFEH	// mark landing pad normal termination
	outprintf (o, i3, '=', RESERVED_1, ';', -1);
ENDIF
	outprintf (o, longjmp_ctx_top, '=', longjmp_ctx, '.', y, ';', '}', -1);

	if (CODE [p] == RESERVED_else) {
		outprintf (o, RESERVED_else, '{', -1);
IFEH		// cleanup eh mess
		outprintf (o, RESERVED_free, '(', longjmp_ctx, '.', i, ')', ';', -1);
ENDIF
		outprintf (o, longjmp_ctx_top, '=', longjmp_ctx, '.', y, ';', -1);

		p = statement (o, p + 1);

		outprintf (o, '}', -1);
	}
	output_itoken (o, '}');

	if (have_retcode) close_local_scope ();

	return p;
}
